/**
 * Copyright (c) 2007-2012, Kaazing Corporation. All rights reserved.
 */

package com.kaazing.gateway.client;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.JsArrayInteger;

public class Charset extends JavaScriptObject {
	protected Charset() {}
	
	private static Charset UTF8 = getUTF8();
	
	public static native Charset getUTF8() /*-{
		return $wnd.Charset.UTF8;
	}-*/;

	public native final String decode(ByteBuffer body) /*-{
		return this.decode(body);
	}-*/;
	
	public native final ByteBuffer encode(String text, ByteBuffer body) /*-{
		return this.encode(text, body);
	}-*/;
	
	public native final JsArrayInteger encodeAsByteArray(String text) /*-{
	    return this.encodeAsByteArray(text);
	}-*/;

	public final byte[] encode(String text) {
		ByteBuffer buffer = ByteBuffer.create();
		UTF8.encode(text, buffer);
		return buffer.getBytes();
	}

	public final String decode(byte[] bytes) {
		ByteBuffer buffer = ByteBuffer.allocate(bytes.length);
		buffer.putBytesAt(0, bytes);
		return UTF8.decode(buffer);
	}

}
